VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form frmmain 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Quicktranslator"
   ClientHeight    =   6495
   ClientLeft      =   150
   ClientTop       =   780
   ClientWidth     =   8730
   Icon            =   "frmmain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6495
   ScaleWidth      =   8730
   StartUpPosition =   3  'Windows Default
   Begin VB.CheckBox chkCase 
      Caption         =   "Case Sensitive"
      Height          =   375
      Left            =   6480
      Style           =   1  'Graphical
      TabIndex        =   5
      Top             =   6120
      Value           =   1  'Checked
      Width           =   2295
   End
   Begin MSFlexGridLib.MSFlexGrid flexGrid 
      Height          =   4935
      Left            =   120
      TabIndex        =   4
      Top             =   1080
      Width           =   8535
      _ExtentX        =   15055
      _ExtentY        =   8705
      _Version        =   393216
      Rows            =   0
      Cols            =   0
      FixedRows       =   0
      FixedCols       =   0
      ForeColorSel    =   0
      BackColorBkg    =   16777215
      ScrollTrack     =   -1  'True
      HighLight       =   2
      ScrollBars      =   2
      SelectionMode   =   1
   End
   Begin VB.TextBox txtinput 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "Zu bersetzendes Wort hier eingeben"
      Top             =   720
      Width           =   8535
   End
   Begin VB.OptionButton opteng 
      Caption         =   "Englisch - Deutsch"
      Height          =   495
      Left            =   4440
      Style           =   1  'Graphical
      TabIndex        =   2
      Top             =   120
      Value           =   -1  'True
      Width           =   4215
   End
   Begin VB.OptionButton optdeu 
      Caption         =   "Deutsch - Englisch"
      Height          =   495
      Left            =   120
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   120
      Width           =   4215
   End
   Begin VB.Line Line1 
      X1              =   0
      X2              =   8760
      Y1              =   6120
      Y2              =   6120
   End
   Begin VB.Label lblstate 
      Height          =   255
      Left            =   0
      TabIndex        =   3
      Top             =   6240
      Width           =   8775
   End
   Begin VB.Menu mnufile 
      Caption         =   "&File"
      Index           =   0
      Begin VB.Menu mnuquit 
         Caption         =   "&Quit"
         Index           =   0
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Index           =   2
      Begin VB.Menu mnuReadMe 
         Caption         =   "&QTrans ReadMe"
         Index           =   0
      End
      Begin VB.Menu mnuLicense 
         Caption         =   "&GNU License"
         Index           =   1
      End
      Begin VB.Menu mnuBeoReadMe 
         Caption         =   "&Beolingus ReadMe"
         Index           =   2
      End
   End
End
Attribute VB_Name = "frmmain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, _
ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
    
Const Language_Separator As String = "::"
Const Meaning_Separator As String = "|"
Const Synonym_Separator As String = ";"
Const Comment_Sign As String = "#"
Const Line_Separator As String = vbCrLf

Private compMod As VbCompareMethod

Private Sub chkCase_Click()
    'switch case sensitive
    If chkCase.Value Then
        compMod = vbBinaryCompare
    Else
        compMod = vbTextCompare
    End If
    txtinput_KeyPress vbKeyReturn
End Sub

Private Sub Form_Load()
    
    txtinput.SelStart = 0
    txtinput.SelLength = Len(txtinput.Text)

    If opteng.Value Then
        lblstate.Caption = "Quicktranslator V." & App.Major & "." & App.Minor & "." & App.Revision & " ist bereit"
    ElseIf optdeu.Value Then
        lblstate.Caption = "Quicktranslator V." & App.Major & "." & App.Minor & "." & App.Revision & " is ready"
    End If
    
    ResetGrid

End Sub

Private Sub flexGrid_Click()
On Error GoTo exitSub
    Clipboard.Clear
    flexGrid.Col = 2
    Clipboard.SetText flexGrid.Text
    If opteng.Value Then
        lblstate.Caption = """" & flexGrid.Text & """ wurde in die Zwischenablage kopiert"
    ElseIf optdeu.Value Then
        lblstate.Caption = """" & flexGrid.Text & """ was copied to the clipboard"
    End If
exitSub:
End Sub

Private Sub mnuBeoReadMe_Click(Index As Integer)
    'ShellExecute 0&, vbNullString, "C:\test.doc", vbNullString, vbNullString, vbNormalFocus
    ShellExecute 0&, vbNullString, """" & App.Path & "\Beolingus Database Readme.txt""", vbNullString, vbNullString, vbNormalFocus
End Sub

Private Sub mnuLicense_Click(Index As Integer)
    ShellExecute 0&, vbNullString, """" & App.Path & "\gpl-2.0.html""", vbNullString, vbNullString, vbNormalFocus
End Sub

Private Sub mnuquit_Click(Index As Integer)
    End
End Sub

Private Sub mnuReadMe_Click(Index As Integer)
    ShellExecute 0&, vbNullString, """" & App.Path & "\read me or not.txt""", vbNullString, vbNullString, vbNormalFocus
End Sub

Private Sub optdeu_Click()
    opteng.Caption = "English - German"
    optdeu.Caption = "German - English"
    chkCase.Caption = "Case sensitive"
    txtinput.Text = "Enter word for translation here"
    txtinput.SetFocus
End Sub

Private Sub opteng_Click()
    opteng.Caption = "Englisch - Deutsch"
    optdeu.Caption = "Deutsch - Englisch"
    chkCase.Caption = "Gro- Kleinschreibung"
    txtinput.Text = "Zu bersetzendes Wort hier eingeben"
    txtinput.SetFocus
End Sub

'select all if got focus
Private Sub txtinput_GotFocus()
    txtinput.SelStart = 0
    txtinput.SelLength = Len(txtinput.Text)
End Sub

'Translate on enter key
Private Sub txtinput_KeyPress(KeyAscii As Integer)
    If txtinput.Text = "" Then Exit Sub
    If KeyAscii = vbKeyReturn Then
        If opteng.Value Then
            lblstate.Caption = "in Arbeit..."
        ElseIf optdeu.Value Then
            lblstate.Caption = "working..."
        End If
        DoEvents
        Translation txtinput.Text
        KeyAscii = 0
        If flexGrid.Rows > 0 Then StandardSelection
    End If
End Sub

'select exact match if existing, else select shortest proposal
Private Sub StandardSelection()
    
    Dim n As Long
    Dim shortestLen As Long
    Dim shortestIndex As Long
    
    shortestLen = -1
    shortestIndex = -1
    
    With flexGrid
        For n = 0 To .Rows - 1
            If LCase(GetField(0, n)) = LCase(txtinput.Text) Then                    'exact match
                .TopRow = n
                Exit Sub
            End If
            If shortestLen = -1 Or shortestLen > Len(GetField(0, n)) Then
                shortestLen = Len(GetField(0, n))
                shortestIndex = n
            End If
        Next n
        
        If shortestIndex <> -1 Then
            .TopRow = shortestIndex
        End If
    End With
    
End Sub

'Remove comments out of string
Private Function RemoveComments(ByRef inp As String) As String

    If Left(inp, 1) = Comment_Sign Then
        RemoveComments = ""
    Else
        RemoveComments = inp
    End If
    
End Function

Private Function ReadFile() As String()
    
    Const testedNumParts As Long = 368578   'change if you change the database
    
    Dim res() As String
    Dim numLine As Long
    Dim currMeaning As Long
    Dim currSynonym As Long
    Dim languageParts() As String
    Dim leftMeanings() As String, rightMeanings() As String
    Dim leftSynonyms() As String, rightSynonyms() As String
    Dim fileNum As Long
    Dim currLine As String
    Dim numParts As Long
    
    ReDim res(1, testedNumParts)
    
    fileNum = FreeFile
    Open App.Path & "\de-en.txt" For Input As #fileNum
    Do Until EOF(fileNum)
        Line Input #fileNum, currLine
        'Line-Syntax:  Ger       ::       Eng
        '{m}; {f} | {pl} [topic] :: {singular} | {plural}
        If Left(currLine, 1) = Comment_Sign Then currLine = ""
        If currLine = "" Then GoTo SkipLoop
        
        'split line in eng / ger part
        'when vb reads umlauts from a file, they end up as a mess in a string
        'Therefore it is neccessary to turn this mess back into 1 character
        languageParts = SplitString(currLine, Language_Separator)
        
        If languageParts(0) = "" Or languageParts(1) = "" Then GoTo SkipLoop                'skip missing translations
        
        'split lang in word parts
        leftMeanings = SplitString(languageParts(0), Meaning_Separator)
        rightMeanings = SplitString(languageParts(1), Meaning_Separator)
        
        For currMeaning = 0 To UBound(leftMeanings)
            'split current meaning in synonyms
            leftSynonyms = SplitString(leftMeanings(currMeaning), Synonym_Separator)
            rightSynonyms = SplitString(rightMeanings(currMeaning), Synonym_Separator)
            
            If leftMeanings(currMeaning) <> "" And rightMeanings(currMeaning) <> "" Then    'skip missing translations
                For currSynonym = 0 To UBound(leftSynonyms)
                    'Not neccessary if number of parts is known
                    'If UBound(res, 2) < numParts Then
                    '    ReDim Preserve res(1, numParts)
                    'End If
                    'Number of synonyms do not need to be equal
                    'Use last index of synonym as fallback
                    If UBound(rightSynonyms) < currSynonym Then
                        res(1, numParts) = rightSynonyms(UBound(rightSynonyms))
                    Else
                        res(1, numParts) = rightSynonyms(currSynonym)
                    End If
                    If UBound(leftSynonyms) < currSynonym Then
                        res(0, numParts) = Replace_Umlauts(leftSynonyms(UBound(rightSynonyms)))
                    Else
                        res(0, numParts) = Replace_Umlauts(leftSynonyms(currSynonym))
                    End If
                    numParts = numParts + 1
                Next currSynonym
            End If
        Next currMeaning
        
        numLine = numLine + 1
        
SkipLoop:
    Loop
    Close #fileNum
    
    ReadFile = res
    
End Function

'create Translation-Tree
Private Sub Translation(ByVal searchStr As String)
    
    Const Break_Limit As Long = 3000
    
    Dim currSynonym As Long
    Dim engGrid As String
    Dim gerGrid As String
    Dim sortGrid As String
    Static trans() As String
    Static initialized As Boolean
    Dim break As Boolean
    Dim transEng As Boolean
    
    If Not initialized Then
        trans = ReadFile
        initialized = True
    End If
    
    transEng = opteng.Value
    ResetGrid
    flexGrid.Redraw = False
    
    For currSynonym = 0 To UBound(trans, 2)
        If Not transEng Then
            If InStr(1, trans(0, currSynonym), searchStr, compMod) > 0 Then   'if synonym contains search string
                engGrid = trans(1, currSynonym)
                gerGrid = trans(0, currSynonym)
                sortGrid = RemoveExtraInfo(gerGrid)
                AddRow sortGrid, gerGrid, engGrid
            End If
        Else
            If InStr(1, trans(1, currSynonym), searchStr, compMod) > 0 Then   'if synonym contains search string
                engGrid = trans(1, currSynonym)
                gerGrid = trans(0, currSynonym)
                sortGrid = RemoveExtraInfo(engGrid)
                AddRow sortGrid, engGrid, gerGrid
            End If
        End If
        If flexGrid.Rows = Break_Limit Then
            break = True
            Exit For
        End If
    Next currSynonym
    
    If flexGrid.Rows > 0 Then SortAll
    flexGrid.Redraw = True
    
    If break Then
        If opteng.Value Then
            lblstate.Caption = "Suche nach " & flexGrid.Rows & " Treffern abgebrochen"
        ElseIf optdeu.Value Then
            lblstate.Caption = "Skipped search after " & flexGrid.Rows & " hits"
        End If

    Else
        If opteng.Value Then
            lblstate.Caption = "Gesuchter Ausdruck kommt " & flexGrid.Rows & " mal in der Datenbank vor"
        ElseIf optdeu.Value Then
            lblstate.Caption = "Searched expression appears " & flexGrid.Rows & " times in the database"
        End If
    End If
    
End Sub

'clean up vb-mess between textfile-read and string (probably no unicode support)
Public Function Replace_Umlauts(ByVal StringInput As String) As String
    
    Dim seperationPos As Long, replace As String, tempStr As String
    
    Do
        seperationPos = InStr(StringInput, "ä")
        If seperationPos > 0 Then
            replace = ""
        Else
            seperationPos = InStr(StringInput, "Ä")
            If seperationPos > 0 Then
                replace = ""
            Else
                seperationPos = InStr(StringInput, "ü")
                If seperationPos > 0 Then
                    replace = ""
                Else
                    seperationPos = InStr(StringInput, "Ü")
                    If seperationPos > 0 Then
                        replace = ""
                    Else
                        seperationPos = InStr(StringInput, "ö")
                        If seperationPos > 0 Then
                            replace = ""
                        Else
                            seperationPos = InStr(StringInput, "Ö")
                            If seperationPos > 0 Then
                                replace = ""
                            Else
                                seperationPos = InStr(StringInput, "ß")
                                If seperationPos > 0 Then
                                    replace = ""
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
        
        If seperationPos > 0 Then
            tempStr = StringInput
            StringInput = Left(tempStr, seperationPos - 1) & replace & Right(tempStr, Len(tempStr) - seperationPos - 1)
        End If
        
    Loop Until seperationPos = 0
    
    Replace_Umlauts = StringInput
    
End Function

'mess up vb string
Public Function Mess_Up_Umlauts(ByVal StringInput As String) As String
    
    Dim seperationPos As Long, replace As String, tempStr As String
    
    Do
        seperationPos = InStr(StringInput, "")
        If seperationPos > 0 Then
            replace = "ä"
        Else
            seperationPos = InStr(StringInput, "")
            If seperationPos > 0 Then
                replace = "Ä"
            Else
                seperationPos = InStr(StringInput, "")
                If seperationPos > 0 Then
                    replace = "ü"
                Else
                    seperationPos = InStr(StringInput, "")
                    If seperationPos > 0 Then
                        replace = "Ü"
                    Else
                        seperationPos = InStr(StringInput, "")
                        If seperationPos > 0 Then
                            replace = "ö"
                        Else
                            seperationPos = InStr(StringInput, "")
                            If seperationPos > 0 Then
                                replace = "Ö"
                            Else
                                seperationPos = InStr(StringInput, "")
                                If seperationPos > 0 Then
                                    replace = "ß"
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
        
        If seperationPos > 0 Then
            tempStr = StringInput
            StringInput = Left(tempStr, seperationPos - 1) & replace & Right(tempStr, Len(tempStr) - seperationPos - 1)
        End If
        
    Loop Until seperationPos = 0
    
    Mess_Up_Umlauts = StringInput
    
End Function

'remove extra information of an entry like appreviation, topic, numerus...
Private Function RemoveExtraInfo(inputStr As String)
    
    Const Start_Numerus As String = "{"
    Const End_Numerus As String = "}"
    Const Start_Appreviation As String = "/"
    Const End_Appreviation As String = "/"
    Const Start_Topic As String = "["
    Const End_Topic As String = "]"
    Const Start_Optional As String = "("
    Const End_Optional As String = ")"
    
    'Language_Separator Meaning_Separator Synonym_Separator
    
    Dim infoPos As Long, infoEnd As Long, sepPos1 As Long, sepPos2 As Long, sepPos3 As Long
    
    RemoveExtraInfo = inputStr
    'Function Replace(Expression As String, Find As String, Replace As String, [Start As Long = 1], [Count As Long = -1], [Compare As VbCompareMethod = vbBinaryCompare]) As String
    
    'remove numerus
    infoPos = InStr(RemoveExtraInfo, Start_Numerus)
    infoEnd = InStr(infoPos + 1, RemoveExtraInfo, End_Numerus)
    sepPos1 = InStr(infoPos + 1, RemoveExtraInfo, Language_Separator)
    sepPos2 = InStr(infoPos + 1, RemoveExtraInfo, Meaning_Separator)
    sepPos3 = InStr(infoPos + 1, RemoveExtraInfo, Synonym_Separator)
    If infoPos > 0 And infoEnd > infoPos And (sepPos1 = 0 Or sepPos1 > infoEnd) And (sepPos2 = 0 Or sepPos2 > infoEnd) And (sepPos3 = 0 Or sepPos3 > infoEnd) Then
        RemoveExtraInfo = Trim(Left(RemoveExtraInfo, infoPos - 1)) & Trim(Right(RemoveExtraInfo, Len(RemoveExtraInfo) - infoEnd))
    End If
    
    'remove Appreviation
    infoPos = InStr(inputStr, Start_Appreviation)
    infoEnd = InStr(infoPos + 1, RemoveExtraInfo, End_Appreviation)
    sepPos1 = InStr(infoPos + 1, RemoveExtraInfo, Language_Separator)
    sepPos2 = InStr(infoPos + 1, RemoveExtraInfo, Meaning_Separator)
    sepPos3 = InStr(infoPos + 1, RemoveExtraInfo, Synonym_Separator)
    If infoPos > 0 And infoEnd > infoPos And (sepPos1 = 0 Or sepPos1 > infoEnd) And (sepPos2 = 0 Or sepPos2 > infoEnd) And (sepPos3 = 0 Or sepPos3 > infoEnd) Then
        RemoveExtraInfo = Trim(Left(RemoveExtraInfo, infoPos - 1)) & Trim(Right(RemoveExtraInfo, Len(RemoveExtraInfo) - infoEnd))
    End If
    
    'remove topic
    infoPos = InStr(inputStr, Start_Topic)
    infoEnd = InStr(infoPos + 1, RemoveExtraInfo, End_Topic)
    sepPos1 = InStr(infoPos + 1, RemoveExtraInfo, Language_Separator)
    sepPos2 = InStr(infoPos + 1, RemoveExtraInfo, Meaning_Separator)
    sepPos3 = InStr(infoPos + 1, RemoveExtraInfo, Synonym_Separator)
    If infoPos > 0 And infoEnd > infoPos And (sepPos1 = 0 Or sepPos1 > infoEnd) And (sepPos2 = 0 Or sepPos2 > infoEnd) And (sepPos3 = 0 Or sepPos3 > infoEnd) Then
        RemoveExtraInfo = Trim(Left(RemoveExtraInfo, infoPos - 1)) & Trim(Right(RemoveExtraInfo, Len(RemoveExtraInfo) - infoEnd))
    End If
    
    'remove optional
    infoPos = InStr(inputStr, Start_Optional)
    infoEnd = InStr(infoPos + 1, RemoveExtraInfo, End_Optional)
    sepPos1 = InStr(infoPos + 1, RemoveExtraInfo, Language_Separator)
    sepPos2 = InStr(infoPos + 1, RemoveExtraInfo, Meaning_Separator)
    sepPos3 = InStr(infoPos + 1, RemoveExtraInfo, Synonym_Separator)
    If infoPos > 0 And infoEnd > infoPos And (sepPos1 = 0 Or sepPos1 > infoEnd) And (sepPos2 = 0 Or sepPos2 > infoEnd) And (sepPos3 = 0 Or sepPos3 > infoEnd) Then
        RemoveExtraInfo = Trim(Left(RemoveExtraInfo, infoPos - 1)) & Trim(Right(RemoveExtraInfo, Len(RemoveExtraInfo) - infoEnd))
    End If
    
    RemoveExtraInfo = Trim(RemoveExtraInfo)
    
End Function

Public Function SplitString(inputStr As String, separator As String, Optional comp As _
    VbCompareMethod = vbBinaryCompare) As String()
    
    Dim sepPos As Long
    Dim res() As String
    Dim lenSep As Long
    
    lenSep = Len(separator)
    inputStr = inputStr
    sepPos = InStr(1, inputStr, separator, comp)
    ReDim res(0)
    
    'Separator found
    While sepPos > 0
        If sepPos - lenSep >= 0 Then
            res(UBound(res)) = RTrim(Left(inputStr, sepPos - lenSep))
            ReDim Preserve res(UBound(res) + 1)
        End If
        If Len(inputStr) - sepPos - lenSep < 0 Then
            sepPos = 0
        Else
            inputStr = LTrim(Right(inputStr, Len(inputStr) - sepPos - lenSep))
            sepPos = InStr(1, inputStr, separator, comp)
        End If
    Wend
    
    'Separator not found
    res(UBound(res)) = RTrim(inputStr)
    SplitString = res
            
End Function

'concatenate string array parts, insert separators
Private Function ConcatStrArray(strArray() As String) As String
    
    Const String_Separator As String = "; "
    
    Dim n As Long
    
    For n = 0 To UBound(strArray)
        ConcatStrArray = ConcatStrArray & strArray(n)
        If n < UBound(strArray) Then ConcatStrArray = ConcatStrArray & String_Separator
    Next n
    
End Function

'resets flexgrid
Private Sub ResetGrid()
    With flexGrid
        .Clear
        .Redraw = False
        .Cols = 3
        .Rows = 0
        .ColWidth(0) = 0 '.Width * 0.3
        .ColWidth(1) = .Width * 0.5
        .ColWidth(2) = .Width * 0.5
        .ColAlignment(0) = 0
        .ColAlignment(1) = 0
        .ColAlignment(2) = 0
        .Redraw = True
    End With
End Sub

'Sort whole table
Private Sub SortAll()
    'http://msdn.microsoft.com/en-us/library/aa261266%28VS.60%29.aspx
    
    With flexGrid
        .Row = 0
        .RowSel = 0
        .Col = 0
        .ColSel = 0
        .Sort = 5 'flexSortStringNoCaseAsending
    End With
    
End Sub

'set new recordset in grid
Private Sub AddRow(sortStr As String, leftStr As String, rightStr As String)
    With flexGrid
        .Rows = .Rows + 1
        SetField 0, .Rows - 1, sortStr
        SetField 1, .Rows - 1, leftStr
        SetField 2, .Rows - 1, rightStr
    End With
End Sub

'Set text of 1 single field
Private Sub SetField(colIndex As Long, rowIndex As Long, newText As String)

    With flexGrid
        .Col = colIndex
        .Row = rowIndex
        .Text = newText
    End With
        
End Sub

'Get text of 1 single field
Private Function GetField(colIndex As Long, rowIndex As Long) As String

    With flexGrid
        .Col = colIndex
        .Row = rowIndex
        GetField = .Text
    End With
        
End Function


